--addon name, addon namespace
local _, ans = ...;

--[[
    LayoutInfoString explanation

    -- There is SetPoint() parameters instruction into the code
    7     | 7             | UIParent   | 0.0     | 45.0
    point | relativePoint | relativeTo | offsetX | offsetY

    -- A number refer to a point
    8 = BOTTOMRIGHT
    7 = BOTTOM
    6 = BOTTOMLEFT
    5 = RIGHT
    4 = CENTER
    3 = LEFT
    2 = TOPRIGHT
    1 = TOP
    0 = TOPLEFT

    To update LayoutInfoString thanks to javascript I did this:
    - export code
    - let mystring = "0 30 0 0 0 7 7 UIParent 0.0 45.0 -1 ##$%%/&('%)$+$ ..."
    - mystring.split(/( -1 [#|$|'|,|&|%|3])/g)
    - remove space jumpline space in vscode
    - work on the result string
    - remove space jumpline space in vscode to have a good modified LayoutInfoString back
--]]
local KdoUiLayoutString = "0 30 0 0 1 7 7 UIParent 0.0 36.0 -1 ##$$%/&('%)$+$ 0 1 0 6 0 MainMenuBar 0.0 2.0 -1 ##$$%/&('%(#,$ 0 2 0 6 8 MainMenuBar 28.0 0.0 -1 ##$%%)&('%(#,$ 0 3 1 5 5 UIParent -5.0 -77.0 -1 #$$$%/&('%(#,$ 0 4 1 2 0 MultiBarRight -5.0 0.0 -1 #$$$%/&('%(#,$ 0 5 0 8 6 MainMenuBar -28.0 0.0 -1 ##$%%)&('%(#,$ 0 6 0 1 4 UIParent 0.0 0.0 -1 ##$$%/&('%(#,$ 0 7 0 1 7 MultiBar6 0.0 0.0 -1 ##$$%/&('%(#,$ 0 10 0 6 0 MultiBarBottomLeft 0.0 2.0 -1 ##$$&('% 0 11 0 6 0 MultiBarBottomLeft 0.0 2.0 -1 ##$$&('%,# 0 12 0 8 2 MultiBarBottomLeft 0.0 2.0 -1 ##$$&('% 1 -1 0 7 1 MainMenuBar 0.0 122.0 -1 ##$# 2 -1 1 2 2 UIParent 0.0 0.0 -1 ##$# 3 0 0 8 7 UIParent -106.0 272.0 -1 $#3# 3 1 0 6 7 UIParent 106.0 272.0 -1 %#3# 3 2 0 3 5 TargetFrame -10.0 -32.0 -1 %#&$3# 3 3 1 0 2 CompactRaidFrameManager 0.0 -7.0 -1 '$(#)#-#.#/#1$3# 3 4 1 0 2 CompactRaidFrameManager 0.0 -5.0 -1 ,#-#.#/#0#1#2( 3 5 1 5 5 UIParent 0.0 0.0 -1 &#*$3# 3 6 1 5 5 UIParent 0.0 0.0 -1 3# 4 -1 0 1 1 UIParent 0.0 -5.0 -1 # 5 -1 0 1 1 UIParent 0.0 -36.0 -1 # 6 0 1 2 0 MinimapCluster -10.0 -10.0 -1 ##$#%#&.(()(*# 6 1 1 2 8 BuffFrame -13.0 -15.0 -1 ##$#%#'+(()(*# 7 -1 0 1 1 UIParent 0.0 -5.0 -1 # 8 -1 0 6 6 UIParent 5.0 5.0 -1 #'$A%$&7 9 -1 0 8 2 MultiBarBottomLeft 0.0 2.0 -1 # 10 -1 1 0 0 UIParent 16.0 -116.0 -1 # 11 -1 0 8 8 UIParent -5.0 5.0 -1 # 12 -1 1 2 2 UIParent -110.0 -275.0 -1 #K";
ans.KdoUiLayoutString = KdoUiLayoutString;

local KdoUiPersonalArenaLayoutString = "0 30 0 0 1 7 7 UIParent 0.0 36.0 -1 ##$$%/&('%)$+$ 0 1 0 6 0 MainMenuBar 0.0 2.0 -1 ##$$%/&('%(#,# 0 2 0 6 8 MainMenuBar 28.0 0.0 -1 ##$%%)&('%(#,# 0 3 1 5 5 UIParent -5.0 -77.0 -1 #$$$%/&('%(&,# 0 4 1 2 0 MultiBarRight -5.0 0.0 -1 #$$$%/&('%(&,# 0 5 0 8 6 MainMenuBar -28.0 0.0 -1 ##$%%)&('%(#,# 0 6 0 1 4 UIParent 0.0 0.0 -1 ##$$%/&('%(#,$ 0 7 0 1 7 MultiBar6 0.0 0.0 -1 ##$$%/&('%(#,$ 0 10 0 6 0 MultiBarBottomLeft 0.0 2.0 -1 ##$$&('% 0 11 0 6 0 MultiBarBottomLeft 0.0 2.0 -1 ##$$&('%,# 0 12 0 8 2 MultiBarBottomLeft 0.0 2.0 -1 ##$$&('% 1 -1 0 7 1 MainMenuBar 0.0 190.0 -1 ##$# 2 -1 1 2 2 UIParent 0.0 0.0 -1 ##$# 3 0 0 8 7 UIParent -106.0 322.0 -1 $#3# 3 1 0 6 7 UIParent 106.0 322.0 -1 %#3# 3 2 0 3 5 TargetFrame -10.0 -32.0 -1 %#&$3# 3 3 0 5 5 UIParent -1735.3 -91.7 -1 '$(#)#-k.G/#1$3# 3 4 1 0 2 CompactRaidFrameManager 0.0 -5.0 -1 ,#-#.#/#0#1#2( 3 5 1 5 5 UIParent 0.0 0.0 -1 &#*$3# 3 6 0 7 1 TargetFrame 24.0 0.0 -1 3. 4 -1 0 1 1 UIParent 0.0 -5.0 -1 # 5 -1 0 1 1 UIParent 0.0 -36.0 -1 # 6 0 1 2 0 MinimapCluster -10.0 -10.0 -1 ##$#%#&.(+)(*# 6 1 1 2 8 BuffFrame -13.0 -15.0 -1 ##$#%#'+(+)(*# 7 -1 0 1 1 UIParent 0.0 -5.0 -1 # 8 -1 0 6 6 UIParent 5.0 5.0 -1 #'$A%$&7 9 -1 0 8 2 MultiBarBottomLeft 0.0 2.0 -1 # 10 -1 1 0 0 UIParent 16.0 -116.0 -1 # 11 -1 0 8 8 UIParent -5.0 5.0 -1 # 12 -1 1 2 2 UIParent -110.0 -275.0 -1 #K";
local KdoUiPersonalLayoutString = "0 30 0 0 1 7 7 UIParent 0.0 36.0 -1 ##$$%/&('%)$+$ 0 1 0 6 0 MainMenuBar 0.0 2.0 -1 ##$$%/&('%(#,$ 0 2 0 6 8 MainMenuBar 28.0 0.0 -1 ##$%%)&('%(#,# 0 3 1 5 5 UIParent -5.0 -77.0 -1 #$$$%/&('%(&,# 0 4 1 2 0 MultiBarRight -5.0 0.0 -1 #$$$%/&('%(&,# 0 5 0 8 6 MainMenuBar -28.0 0.0 -1 ##$%%)&('%(#,# 0 6 0 1 4 UIParent 0.0 0.0 -1 ##$$%/&('%(#,$ 0 7 0 1 7 MultiBar6 0.0 0.0 -1 ##$$%/&('%(#,$ 0 10 0 6 0 MultiBarBottomLeft 0.0 2.0 -1 ##$$&('% 0 11 0 6 0 MultiBarBottomLeft 0.0 2.0 -1 ##$$&('%,# 0 12 0 8 2 MultiBarBottomLeft 0.0 2.0 -1 ##$$&('% 1 -1 0 7 1 MainMenuBar 0.0 190.0 -1 ##$# 2 -1 1 2 2 UIParent 0.0 0.0 -1 ##$# 3 0 0 8 7 UIParent -106.0 322.0 -1 $#3# 3 1 0 6 7 UIParent 106.0 322.0 -1 %#3# 3 2 0 3 5 TargetFrame -10.0 -32.0 -1 %#&$3# 3 3 0 4 4 UIParent -421.2 -4.1 -1 '$(#)#-k.G/#1$3# 3 4 0 5 3 PlayerFrame 16.0 143.0 -1 ,#-k.C/#0#1#2( 3 5 1 5 5 UIParent 0.0 0.0 -1 &#*$3# 3 6 1 5 5 UIParent 0.0 0.0 -1 3# 4 -1 0 1 1 UIParent 0.0 -5.0 -1 # 5 -1 0 1 1 UIParent 0.0 -36.0 -1 # 6 0 1 2 0 MinimapCluster -10.0 -10.0 -1 ##$#%#&.(+)(*# 6 1 1 2 8 BuffFrame -13.0 -15.0 -1 ##$#%#'+(+)(*# 7 -1 0 1 1 UIParent 0.0 -5.0 -1 # 8 -1 0 6 6 UIParent 5.0 5.0 -1 #'$A%$&7 9 -1 0 8 2 MultiBarBottomLeft 0.0 2.0 -1 # 10 -1 1 0 0 UIParent 16.0 -116.0 -1 # 11 -1 0 8 8 UIParent -5.0 5.0 -1 # 12 -1 1 2 2 UIParent -110.0 -275.0 -1 #K";

--[[
    LayoutInfo structure
    1- MainBar
    2- Bar2
    3- Bar3
    4- RightBar1
    5- RightBar2
    6- ExtraBar1
    7- ExtraBar2
    8- ExtraBar3
    9- StanceBar
    10- PetActionBar
    11- PossessActionBar
    12- CastBar
    13- Minimap
    14- Player
    15- Target
    16- Focus
    17- Party
    18- Raid
    19- Boss
    20- Arena
    21- EncounterBar
    22- ExtraAbilities
    23- BuffFrame
    24- DebuffFrame
    25- TalkingHeadFrame
    26- ChatFrame
    27- VehicleLeaveButton
    28- LootFrame
    29- HudTooltip
    30- ObjectiveTracker

    Call C_EditMode.ConvertLayoutInfoToString(KdoUiLayoutInfo) to convert it into a valid string
--]]
